library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all;

entity top is port (
--hd,hu,md,mu,sd,su : in std_logic_vector(3 downto 0);
clk : in std_logic;
hl : in std_logic;
seg_hd,seg_hu,seg_md,seg_mu,seg_sd,seg_su : out std_logic_vector(6 downto 0)
);
end entity;

architecture behavior of top is

component transco_reveil is port (
	e : in std_logic_vector(3 downto 0);	-- valeur en entree a afficher
	hl : in std_logic;		-- gestion anode commune ou cathode commune 
	s : out std_logic_vector(6 downto 0) 	--	gestion des segments
	);
end component;

component cpt_horloge is port (
	clk,load,clr,en : in std_logic;	
	max : in std_logic_vector(3 downto 0);		-- valeur max du compteur
	din : in std_logic_vector(3 downto 0);		-- valeur de prechargement du compteur
	enout : out std_logic; 
	s : out std_logic_vector(3 downto 0) 	
	);
end component;

component DDS is
		port(
			clk: in std_logic;
			dn: in std_logic_vector(31 downto 0);
			clk_out : out std_logic
				);
		end component;

signal clk1hz : std_logic;
signal hsu,hsd,hmu,hmd,hhu,hhd : std_logic_vector(3 downto 0);
signal endday : std_logic;
signal ensd,enmu,enmd,enhu,enhd : std_logic;

begin

--quartz_1hz : dds port map (clk=>clk, clk_out=> clk1hz, dn =>x"00000056");
quartz_10hz : dds port map (clk=>clk, clk_out=> clk1hz, dn =>x""); -- A COMPLETER

aff_su: transco_reveil port map (e=>hsu,hl=>hl,s=>seg_su);
aff_sd: transco_reveil port map (e=>hsd,hl=>hl,s=>seg_sd);
aff_mu: transco_reveil port map (e=>hmu,hl=>hl,s=>seg_mu);
aff_md: transco_reveil port map (e=>hmd,hl=>hl,s=>seg_md);
aff_hu: transco_reveil port map (e=>hhu,hl=>hl,s=>seg_hu);
aff_hd: transco_reveil port map (e=>hhd,hl=>hl,s=>seg_hd);

cpt_su : cpt_horloge port map(clk=> clk1hz, load=>'0', clr=>endday, en=>'1', max=> "", din=> "0001", enout=> ensd, s=> hsu); -- A COMPLETER
cpt_sd : cpt_horloge port map(clk=> clk1hz, load=>'0', clr=>endday, en=>ensd, max=> "", din=> "0001", enout=> enmu, s=> hsd); -- A COMPLETER
cpt_mu : cpt_horloge port map(clk=> clk1hz, load=>'0', clr=>endday, en=>enmu, max=> "1001", din=> "0001", enout=> enmd, s=> hmu); -- A COMPLETER
cpt_md : cpt_horloge port map(clk=> clk1hz, load=>'0', clr=>endday, en=>enmd, max=> "0101", din=> "0001", enout=> enhu, s=> hmd); -- A COMPLETER
cpt_hu : cpt_horloge port map(clk=> clk1hz, load=>'0', clr=>endday, en=>enhu, max=> "1001", din=> "0001", enout=> enhd, s=> hhu); -- A COMPLETER
cpt_hd : cpt_horloge port map(clk=> clk1hz, load=>'0', clr=>endday, en=>enhd, max=> "0010", din=> "0001", s=> hhd); -- A COMPLETER

process(hsu,hsd,hmu,hmd,hhu,hhd) begin
 if (hsu= and hsd= and hmu= and hmd= and hhu= and hhd=) then
	endday <= '1';
 else
	endday <= '0';
 end if;
end process;
	
end behavior;

